#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <cstring>
using namespace std;
long long int T,N,M,K,P,cnt=0,ans=1;
bool lb=false;

bool bv[100005];
bool dv[100005];
int f[300005];
long long int dist[100005];

struct Pk
{
	int tar;
	int nex;
	int cap;
	int fir;
}pk[200005];

void add(int a,int b,int c)
{
	cnt++;
	pk[cnt].tar=b;
	pk[cnt].cap=c;
	pk[cnt].nex=pk[a].fir;
	pk[a].fir=cnt;
}

int spfa()
{
	int head=1,tail=2;
	for(int i=0;i<=N;i++){bv[i]=false;dist[i]=(1<<29)-1;}
	for(int i=0;i<=300004;i++)f[i]=0;
	bv[1]=true;dist[1]=0;
	f[head]=1;
	
	while(head<tail)
	{
		for(int tmp=pk[f[head]].fir;tmp;tmp=pk[tmp].nex)
		{
			if(dist[f[head]]+pk[tmp].cap<dist[pk[tmp].tar])
			{
				dist[pk[tmp].tar]=dist[f[head]]+pk[tmp].cap;
				if(!bv[pk[tmp].tar])
				{
					f[tail]=pk[tmp].tar;
					tail++;
					bv[pk[tmp].tar]=true;
				}
			}
		}
		bv[head]=false;
		head++;
	}
}

int dfs(int a)
{
	if(a==N)return 0;
	dv[a]=true;
	for(int tmp=pk[a].fir;tmp;tmp=pk[tmp].nex)
	{	
		int tp;
		if(!dv[pk[tmp].tar])
		{
			if(pk[tmp].cap==0)lb=true;
			dv[pk[tmp].tar]=true;
			tp=dfs(pk[tmp].tar)+pk[tmp].cap;
			if(a==1&&tp<=dist[N]+K)ans++;
			dv[pk[tmp].tar]=false;
		}
	}
	return 0;
}

int main()
{
	int a,b,c;
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	
	scanf("%d",&T);
	for(int i=0;i<=N;i++)dv[i]=false;
	for(int i=1;i<=T;i++)
	{
		ans=1;
		scanf("%d%d%d%d",&N,&M,&K,&P);
		for(int j=1;j<=M;j++)
		{
			scanf("%d%d%d",&a,&b,&c);
			add(a,b,c);
		}
		spfa();
		dfs(1);
		cout<<(ans+P)%P<<endl;
		for(int i=1;i<=M+5;i++)
		{	
			pk[i].cap=0;
			pk[i].fir=0;
			pk[i].nex=0;
			pk[i].tar=0;
		}
	}
	return 0;
}
