#include <utility>
#include <cstring>
#include <cstdio>
#include <stack>
#include <set>

using namespace std;

const int MAXN = 1e3;
const int INF = 1e9;

struct nd
{
	char s[MAXN];
	
	bool operator < (const nd &rhs) const
	{
		return strcmp(s, rhs.s)<=0 ? 0 : 1;
	}
};

set<nd> vis;
stack<nd> st;

int max(int a, int b)
{
	return a>b ? a : b;
}

int main()
{
	freopen("complexity.in", "r", stdin);
	freopen("complexity.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while(T--)
	{
		int ans = 0, t = 0, flag = 0;
		bool ok = true;
		int tot = 0;
		int n;
		char s[MAXN], ss[MAXN], sss[MAXN], ssss[MAXN], val[MAXN];
		while(!st.empty())
		{
			nd x = st.top();
			st.pop();
			vis.erase(x);
		}
		memset(s, 0, sizeof(s));
		memset(ss, 0, sizeof(ss));
		memset(sss, 0, sizeof(sss));
		memset(ssss, 0, sizeof(ssss));
		memset(val, 0, sizeof(val));
		scanf("%d O(%s)", &n, &s);
		if(s[0] != '1')
		{
			int cur = 2;
			while(s[cur] != ')')
			{
				tot = tot * 10 + s[cur] - '0';
				cur++;
			}
		}
		for(int i = 0; i < n; ++i)
		{
			scanf("%s", &ss);
			if(ss[0] == 'E')
			{
				if(st.empty())
				{
					ok = false;
					break;
				}
				nd x = st.top();
				st.pop();
				vis.erase(x);
				t--;
				flag--;
				if(flag < 0)
					flag = 0;
			}
			else if(ss[0] == 'F')
			{
				if(flag)
					flag++;
				nd x;
				memset(x.s, 0, sizeof(x.s));
				int cur = 0;
				scanf("%s", &val);
				while(val[cur])
				{
					x.s[cur] = val[cur];
					cur++;
				}
				if(vis.count(x))
				{
					ok = false;
					break;
				}
				vis.insert(x);
				st.push(x);
				cur = 0;
				int a, b;
				a = b = 0;
				scanf("%s", &sss);
				if(sss[cur] == 'n')
					a = INF;
				else
				{
					while(sss[cur])
					{
						a = a * 10 + sss[cur] - '0';
						cur++;
					}
				}
				cur = 0;
				scanf("%s", &ssss);
				if(ssss[cur] == 'n')
					b = INF;
				else
				{
					while(ssss[cur])
					{
						b = b * 10 + ssss[cur] - '0';
						cur++;
					}
				}
				if(a > b)
					flag++;
				else if(b == INF && a != INF && flag == 0)
					ans = max(ans, ++t);
				else
					t++;
			}
		}
		if(!st.empty())
			ok = false;
		if(!ok)
			printf("ERR\n");
		else if(ans == tot)
			printf("Yes\n");
		else
			printf("No\n");
	}
	return 0;
}
