#include <iostream>
using namespace std;

int T;
int n,m,k,p;
int cnt;
int dist[1003][1003];
bool used[1003];
int tmp;

void dfs( int step, int last)
{
	if ( step==n+1 ){
		tmp += dist[last][n];
		if ( tmp<=dist[1][n]+k ){
			cnt++;
		}
		return ;
	}
	else {
		for ( int i=2; i<n; i++){
			if ( !used[i] ){
				tmp += dist[last][i];
				used[i] = 1;
				dfs(step+1,i);
				used[i] = 0;
				tmp -= dist[last][i];
			}
		}
	}
}

int main()
{
	ios::sync_with_stdio(false);
	
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	
	cin >> T;
	for ( int t=0; t<T; t++){
		cin >> n >> m >> k >> p;
		
		for ( int i=1; i<=5; i++){
			for ( int j=1; j<=5; j++){
				dist[i][j] = 1<<28;
			}
			dist[i][i] = 0;
		}
		
		for ( int i=0; i<m; i++){
			int x,y,w;
			cin >> x >> y >> w;
			dist[x][y] = min(dist[x][y],w);
		}
		
		int flag = 0;
		for ( int k=1; k<=n; k++){
			for ( int i=1; i<=n; i++){
				for ( int j=1; j<=n; j++){
					if ( dist[i][j]>dist[i][k]+dist[k][j] ){
						dist[i][j] = dist[i][k]+dist[k][j];
						if ( i==1 && j==n ){
							flag = 1;
						}
					}
				}
			}
		}
		
		cnt = !flag;
		for ( int i=3; i<=n; i++){
			tmp = 0;
			for ( int j=1; j<=n; j++){
				used[j] = 0;
			}
			dfs(i,1);
		}
		
		cout << cnt%p << endl;
	}
	
	return 0;
}
