# include <iostream>
# include <cstdio>
using namespace std;
const int maxn = 1010;
const int oo = 35214589;
int t, n, m, k, p, a, b, c, hope, ans;
int dis[maxn], G[maxn][maxn], head[maxn], num;
bool vis[maxn];
inline void read(int & x) {
	char ch = getchar(); x = 0;
	while(ch < '0' || '9' < ch) ch = getchar();
	while('0' < ch && ch < '9') x = x * 10 + ch - '0', ch = getchar();
	return;
}
inline int DIS() {
	for(int i = 0; i <= n; i++) dis[i] = oo, vis[i] = false;
	dis[1] = 0;
	for(int i = 1; i <= n; i++) {
		int x = 0;
		for(int j = 1; j <= n; j++) 
			if(vis[j] == false && dis[j] < dis[x]) x = j;
		vis[x] = true;
		for(int j = 1; j <= n; j++)
			dis[j] = min(dis[j], dis[x] + G[x][j]);
	}
	return dis[n];
}
inline void dfs(int v, int now) {
	for(int i = 1; i <= n; i++) 
		if(G[v][i] != oo)  {
			if(i == n && now <= hope) {
				ans = (ans + 1) % p;
				continue;
			}
			if(now + G[v][i] > hope) continue;
			if(i != n) dfs(i, now + G[v][i]);
		}
			
	return;
}
int main() {
	freopen("park.in", "r", stdin);
	freopen("park.out", "w", stdout);
	read(t);
	while(t--) {
		read(n), read(m), read(k), read(p);
		for(int i = 1; i <= n; i++)
			for(int j = 1; j <= n; j++) G[i][j] = oo;
		for(int i = 1; i <= m; i++) {
			read(a), read(b), read(c);
			G[a][b] = c;
		}
		hope = DIS() + k;
		dfs(1, 0);
		printf("%d\n", ans % p);
	}
	return 0;
}
