#include<iostream>
#include<cstring>
#include<cstdio>
#include<algorithm>
#include<string>
using namespace std;

const int maxn=105,INF=1<<30;
string s[maxn];
bool vis[maxn*2]={0};


bool pd_err(int l) {
	memset(vis,0,sizeof(vis));
	int top=0;
	char st[maxn]={0};
	for (int i=0;i<l;++i) {
		if (s[i][0]=='F') {
			st[top++]=s[i][2];
			if (vis[s[i][2]]) return 1;
			vis[s[i][2]]=1;
		} else {
			top--;
			vis[st[top]]=0;
		}
	}
	if (top) return 1;
	return 0;
}

void read(string &s) {
	char c=getchar();
	while (c==' '||c=='\n')  c=getchar();
	s="";
	while (c!='\n') {
		s+=c;
		c=getchar();
	}
}


void jump(int &i) {
	int a=1;
	i++;
	while (a) {
		if (s[i][0]=='E') a--;
		else a++;
		i++;
	}
}

bool pd_fzd(int l,const string &fzd)  {
	int c[maxn]={0},top=0,n=0,ans=0;
	for (int i=0;i<l;++i) {
		if (s[i][0]=='F')  {
			//cout<<s[i]<<endl;
			int j,a=0,b=0;
			for (j=4;j<s[i].size();++j) {
				if (s[i][j]=='n') {
					a=-1;	j++;	break;
				}
				if (s[i][j]==' ') break;
				a=a*10+s[i][j]-'0';
			}
			for (j=j+1;j<s[i].size();++j) {
				if (s[i][j]=='n') {
					b=-1;	break;
				}
				if (s[i][j]==' '||s[i][j]=='n') break;
				b=b*10+s[i][j]-'0';
			}
			if (a==-1) a=INF;
			if (b==-1) b=INF;
			if (a>b) jump(i);
			else {
				if (b==INF&&b>a) {
					n++;
					ans=max(ans,n);
					c[top++]=1;
				}
				else c[top++]=0;
			}
		}
		else {
			top--;
			n-=c[top];
		}
	}
	if (fzd[2]=='1') {
		return !(ans==0);
	}
	else {
		int n=0;
		//cout<<fzd<<' '<<ans<<' ';
		for (int j=4;j<fzd.size();++j) {
			if (!isdigit(fzd[j])) break;
			n=n*10+fzd[j]-'0';
		}
		//cout<<n<<endl;
		return !(ans==n);
	}
}

 void work(int l,string fzd) {
	for (int i=0;i<l;++i)  read(s[i]);
	
	 if (pd_err(l)) {
		 printf("ERR\n");
		 return;
	 }
	 
	 if (pd_fzd(l,fzd)) {
		 printf("No\n");
		 return;
	 }
	 printf("Yes\n");
 }

int main() {
	freopen("complexity.in","r",stdin);
	freopen("complexity.out","w",stdout);
	int t;		cin>>t;
	while (t--) {
		int l;
		string fzd; 
		cin>>l>>fzd;
		work(l,fzd);
	}
	return 0;
}
// this problem is written by gzzx wzt
// in fact I am not sure weather it will ac
// god bless me !