#include"iostream"
#include"stdio.h"
#include"string.h"
#include"queue"
using namespace std;

#define MAXN 100050
#define MAXM 200050

struct Edge
{
	int to,next,w;
}edge[MAXM];

int cnt,head[MAXN];

inline void addedge(int u,int v,int w)
{
	edge[++cnt]=(Edge){v,head[u],w};
	head[u]=cnt;
}

int dis[MAXN];
bool inq[MAXN];
queue<int> q;

int spfa(int s,int n)
{
	q.push(s);
	inq[s]=true;
	memset(dis,127,sizeof(dis));
	dis[s]=0;
	while(!q.empty())
	{
		int x=q.front(); q.pop();
	//	cout<<x<<endl;
		inq[x]=false;
		for(int i=head[x];i;i=edge[i].next)
		{
			if(edge[i].w+dis[x]<dis[edge[i].to])
			{
				dis[edge[i].to]=dis[x]+edge[i].w;
				if(!inq[edge[i].to]) 
				{
					inq[edge[i].to]=true;
					q.push(edge[i].to);
				}
			}
		}
	}
	return dis[n];
}

int ans;
int pre[MAXN];
bool vis[MAXN];
int n;

void dfs(int now,int cost,int maxc,bool inf,int mod)
{
//	cout<<now<<endl;
	if(ans==-1) return;
	if(now!=n&&vis[now]&&cost==pre[now]) {
		inf=true; 
	}
	vis[now]=true;
	pre[now]=cost;
	if(cost>maxc) return ;
	if(now==n) 
	{
		if(cost<=maxc) 
		{
			ans++;
			if(inf)
			{
				ans=-1;
			}
		}
		ans%=mod;
	//	return ;
	}
	for(int i=head[now];i;i=edge[i].next)
	{
		dfs(edge[i].to,edge[i].w+cost,maxc,inf,mod);
	}
}

int main()
{
	freopen("park.in","r",stdin);
	freopen("park.ans","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		memset(head,0,sizeof(head));
		memset(edge,0,sizeof(edge));
		memset(vis,0,sizeof(vis));
		memset(pre,0,sizeof(pre));
		ans=0;
		int m,k,p;
		scanf("%d%d%d%d",&n,&m,&k,&p);
		int u,v,w;
		for(int i=1;i<=m;i++)
		{
			scanf("%d%d%d",&u,&v,&w);
			addedge(u,v,w);
		}
		int lowd;
		lowd=spfa(1,n);
		dfs(1,0,lowd+k,false,p);
		cout<<ans<<endl;
	}
	return 0;
}


