#include<cstdlib>
#include<cstdio>
#include<cstring>
#include<string>
#include<queue>
#include<vector>
#include<iostream>
#include<algorithm>
using namespace std;
const int maxn=200000+32;
const int inf=1000000000;
int v[maxn],nex[maxn],w[maxn],g[maxn];
int inq[maxn];
int cnt[maxn];
int d[maxn];

int eid;
int n,m,k,p,t;

void addedge(int from,int to,int x)
{
	 v[++eid]=to;
	 nex[eid]=g[from];
	 g[from]=eid;
	 w[eid]=x;	
}
struct Edge
{
	int from,to,w;
};	
vector<Edge>edges;	
vector<int>z[maxn];
void addedge1(int from,int to,int w)
{
	edges.push_back((Edge){from,to,w});
	int x=edges.size();
	z[from].push_back(x-1);	
}
void spfa()
{
		queue<int >Q;
		for(int i=1;i<=n;i++)
			d[i]=inf;
			Q.push(1);
			d[1]=0;
			cnt[1]=1;
			while(!Q.empty())
			{
				int u=Q.front();
				Q.pop();
				inq[u]=0;
				for(int i=g[u];i+1;i=nex[i])
				{
					int t=v[i];
					if(d[t]>d[u]+w[i])
					{
						d[t]=d[u]+w[i];
						if(!inq[t])
						{
							Q.push(t);
							inq[t]=1;
							if(++cnt[t]>n) break;	
						}	
					}
				}
					
			}			
}	
int dfs(int u)
{
	if(u==1) return 1;
	int ans=0;
	int t=z[u].size();
	for(int i=0;i<t;i++)
	{
	 	Edge & e=edges[z[u][i]];
		if(d[e.to]==d[u]-e.w)
		{
			ans+=dfs(e.to);
		}
	}
	
	return ans;
}
int main()
{
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	scanf("%d",&t);

	while(t--)
	{
		scanf("%d%d%d%d",&n,&m,&k,&p);
		memset(v,0,sizeof(v));
		memset(w,0,sizeof(w));
		memset(g,-1,sizeof(g));
		memset(nex,0,sizeof(nex));
		memset(inq,0,sizeof(inq));
		memset(cnt,0,sizeof(cnt));
		for(int i=1;i<=n;i++) z[i].clear();
		edges.clear();
	//	if(k==0)
		//{
			for(int i=1;i<=m;i++)
			{
				int u,v,w;
				scanf("%d%d%d",&u,&v,&w);
				addedge(u,v,w);	
				addedge1(v,u,w);
			}		
			spfa();
			printf("%d\n",dfs(n)%p);
		
	//	}	
		
	}
	
 //system("PAUSE");
	return 0;
}
