#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int INF=1<<30;
int n,m,k,p,d,ans;
int Edge[1005][1005];
int dis[1005];
int vis[1005];

int Dijistra(){
	memset(vis,0,sizeof(vis));
	vis[1]=1;
	for(int i=1;i<=n;i++)
		dis[i]=Edge[1][i];
	int pos=1,Min=INF;
	for(int i=2;i<=n;i++){
		Min=INF;
		for(int j=1;j<=n;j++){
			if(!vis[j]&&Min>dis[j]){
				Min=dis[j];
				pos=j;
			}
		}
		vis[pos]=1;
		dis[pos]=Min;
		for(int j=1;j<=n;j++){
			if(!vis[j]&&Edge[pos][j]+dis[pos]<dis[j])
				dis[j]=Edge[pos][j]+dis[pos];
		}
	}
	return dis[n];
}

void DFS(int pos,int nowL){
	if(vis[pos]>1000){
		ans=-1;
		return;
	}
	if(nowL>d) return;
	if(pos==n){
		ans++;
		ans%=p;
		return;
	}
	for(int i=1;i<=n;i++){
		if(i==pos) continue;
		if(Edge[pos][i]<INF){
			DFS(i,nowL+Edge[pos][i]);
		}
	}
}

int main(){
	freopen("park.in","r",stdin);freopen("park.out","w",stdout);
	int T;scanf("%d",&T);
	while(T--){
		ans=0;
		scanf("%d%d%d%d",&n,&m,&k,&p);
		if(n>1000&&k==0){
			printf("1\n");
			continue;
		}
		for(int i=1;i<=n;i++)
			for(int j=1;j<=n;j++){
				if(i==j) Edge[i][j]=0;
				else Edge[i][j]=INF;
			}
		while(m--){
			int a,b,c;
			scanf("%d%d%d",&a,&b,&c);
			Edge[a][b]=c;
		}
		d=Dijistra();
		d+=k;
		memset(vis,0,sizeof(vis));
		DFS(1,0);
		printf("%d",ans);
		if(T) printf("\n");
	}
	fclose(stdin);fclose(stdout);
	return 0;
}

