#include <iostream>
#include <cstring>
#include <cstdio>
#include <queue>
#define INF 0x7f7f7f7f

using namespace std;

int f[1050][1050],n,m,d,k,p,maxn,t,g[1050],k1,vis[1050],dis[1050],cnt,o[1050];

struct edge{
	int v,n,w;
}edges[2050];


void addedge(int u,int v,int w)
{
	edges[k1].v=v;
	edges[k1].w=w;
	edges[k1].n=g[u];
	g[u]=k1++;
}

bool spfa()
{
	queue <int> q;
	dis[1]=0;
	q.push(1);
	vis[1]=1;
	while(!q.empty())
	{
		int t=q.front();
		q.pop();
		vis[t]=0;
		for(int i=g[t];i!=-1;i=edges[i].n)
		{
			edge e=edges[i];
			if(dis[e.v]%p>(dis[t]+e.w)%p)
			{
				dis[e.v]=(dis[t]+e.w)%p;
				if(!vis[t])
				{
					q.push(e.v);
					vis[e.v]=1;
				}
			}
		}
	}
}

int main()
{
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	int x,y,z;
	scanf("%d",&t);
	while(t--)
	{
		memset(f,INF,sizeof(f));
		memset(dis,INF,sizeof(dis));
		memset(g,-1,sizeof(g));
		scanf("%d%d%d%d",&n,&m,&k,&p);
		for(int j=1;j<=m;j++)
		{
			scanf("%d%d%d",&x,&y,&z);
			f[x][y]=z;
			if(y==n)
			{
				o[x]=1;
			}
			addedge(x,y,z);
		}
		cnt=0;
		spfa();
		d=dis[n]%p;
		for(int k2=1;k2<=n;k2++)
		{
			for(int i=1;i<=n;i++)
			{
				for(int j=1;j<=n;j++)
				{
					f[i][j]=min(f[i][j]%p,(f[i][k2]+f[k2][j])%p);
				}
			}	
			if(o[k2]==1&&f[1][n]<=d+k)
				{
					cnt++;
				}
		}
		if(f[1][n]==0&&f[n][1]==0)
		{
			printf("-1\n");
			continue;
		}
		printf("%d\n",cnt);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
