#include <cstdio>
#include <cstring>

using namespace std;

const int MAXN = 1e8;
int a, b;
bool vis[MAXN];
int ans[MAXN];

int min(int x, int y)
{
	return x < y ? x : y;
}

int main()
{
	freopen("math.in", "r", stdin);
	freopen("math.out", "w", stdout);
	scanf("%d%d", &a, &b);
	int t = min(a*b, MAXN);
	if(t < 0)
	{
		printf("%lld\n", (long long)a*b-1);
		return 0;
	}
	for(int i = 0; i*a <= t; ++i)
		for(int j = 0; j*b <= t; ++j)
			if(j*b+i*a < MAXN)
				vis[j*b+i*a] = true;
	int cur = 0;
	for(int i = 1; i < t; ++i)
		if(!vis[i])
			ans[cur++] = i;
	printf("%d\n", ans[cur-1]);
	return 0;
}
