#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
using namespace std;
const int MAXN=100010;
const int INF=1<<30;
int dis[MAXN];
int spath[MAXN];
bool vis[MAXN];
struct node{
	int to,dis;
};
vector<node> v[MAXN];
int t,n,m,k,p;

void Init6(){
	int x,y,z;
	node a;
	scanf("%d%d%d%d",&n,&m,&k,&p);
	for(int i=1;i<=n;i++){
		v[i].clear();
	}
	for(int i=1;i<=m;i++){
		scanf("%d%d%d",&x,&y,&z);
		a.to=y,a.dis=z;
		v[x].push_back(a);
	}
}

void Dijkstra(){
	memset(spath,0,sizeof(spath));
	for(int i=1;i<=n;i++){
		dis[i]=INF;
	}
	spath[1]=1;
	dis[1]=0;
	while(1){
		int f=-1,minS=INF;
		for(int i=1;i<=n;i++){
			if(!vis[i]&&dis[i]!=INF&&dis[i]<minS){
				f=i;
				minS=dis[i];
			}
		}
		if(f==-1) break;
		vis[f]=true;
		vector<node>::iterator ii;
		for(ii=v[f].begin();ii!=v[f].end();ii++){
			if(vis[(*ii).to]) continue;
			if(dis[(*ii).to]>dis[f]+(*ii).dis){
				spath[(*ii).to]=spath[f];
				dis[(*ii).to]=dis[f]+(*ii).dis;
			}
			else if(dis[(*ii).to]==dis[f]+(*ii).dis){
				spath[(*ii).to]=(spath[(*ii).to]+spath[f])%p;
			}
		}
	}
}

int main(){
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	scanf("%d",&t);
	for(int i=1;i<=t;i++){
		Init6();
		if(k!=0){
			printf("-1\n");
			continue;
		}
		Dijkstra();
		printf("%d\n",spath[n]);
	}
	fclose(stdin);fclose(stdout);
	return 0;
}
