#include<cstdio>
#include<iostream>
#include<algorithm>
#include<string>
#include<cstring>
#include<queue>
const int MAXE = 200500;
const int MAXV = 100500;
using namespace std;
struct Edge{
	int t,v,next;
}ed[MAXE];
int h[MAXV],size=0;
int n,m,k,p,T,f,t,w;
void AddEdge(int fr,int to,int w)
{
	ed[++size].t=to;
	ed[size].v=w;
	ed[size].next=h[fr];
	h[fr]=size;
}
struct Heapnode{
	int n,d;
	bool operator < (const Heapnode &rhs) const {
		return d>rhs.d;
	}
};
int inq[MAXV],dis[MAXV];
void Dijk(int sour)
{
	memset(inq,0,sizeof(inq));
	memset(dis,0x3f,sizeof(dis));
	priority_queue<Heapnode> q;
	q.push((Heapnode){sour,0});
	dis[sour]=0;
	while(!q.empty())
	{
		Heapnode nw=q.top(); q.pop();
		int np=nw.n,nd=nw.d;
		if(inq[np]) continue;
		for(int i=h[np];i!=0;i=ed[i].next)
		{
			if(dis[ed[i].t]>nd+ed[i].v)
			{
				dis[ed[i].t]=nd+ed[i].v;
				q.push((Heapnode){ed[i].t,dis[ed[i].t]});
			}
		}
		inq[np]=1;
	}
}
int ans;
int dfs(int a,int dep)
{
	if(dep>dis[n]+k) return 0;
	inq[a]=dep;
	if(a==n) ans=(ans+1)%p;
	for(int i=h[a];i!=0;i=ed[i].next)
	{
		if(inq[ed[i].t]==inq[a]) return 1;
		if(dfs(ed[i].t,ed[i].v+dep)) return 1;
	}
	inq[a]=-1;
	return 0;
}
int main()
{
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	scanf("%d",&T);
	for(int i=1;i<=T;i++)
	{
		ans=0;
		scanf("%d %d %d %d",&n,&m,&k,&p);
		for(int i=1;i<=m;i++)
		{
			scanf("%d %d %d",&f,&t,&w);
			AddEdge(f,t,w);
		}
		Dijk(1);
		memset(inq,-1,sizeof(inq));
		int stat=dfs(1,0);
		if(stat==1) {printf("-1\n"); continue;}
		printf("%d\n",ans%p);
	}
	return 0;  
}
