#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cctype>
#include <list>
#include <vector>
#include <stack>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cstring>
#include <iostream>
#include <sstream>
#define ll long long

using namespace std;

int t=0,pipei=0;
set<string> defd;
set<string> localdefd;
vector<vector<string> > comps;
int index[100];

int toi(const string &str){
    int ret=0,len=str.length();
    for(int i=0;i<len;++i){
        ret*=10;
        ret+=str[i]-'0';
    }
    return ret;
}

string tos(int x){
    string ret="";
    do{
       ret.push_back((char)((x%10)+'0'));
    }while(x/=10);
    ret.reserve();
    return ret;
}


string operator * (const string &a,const string &b){
    if(b=="O(1)")return a;
    if(a=="O(1)")return b;
    int ma=toi(a.substr(4,a.length()-1));
    int mb=toi(b.substr(4,b.length()-1));
    return "O(n^"+tos(ma*mb)+")";
}

string max(const string &a,const string &b){
    if(b=="O(1)")return a;
    if(a=="O(1)")return b;
    int ma=toi(a.substr(4,a.length()-1));
    int mb=toi(b.substr(4,b.length()-1));
    return "O(n^"+tos(max(ma,mb))+")";
}


int main(){
    ios::sync_with_stdio(false);
    freopen("complexity.in","r",stdin);
    freopen("complexity.out","w",stdout);
    cin>>t;
    while(t--){
        int L;
        string comp_std;
        vector<string> _comps;
        cin>>L>>comp_std;
        if(L%2){
            cout<<"ERR"<<endl;
            break;
        }
        pipei=0;
        defd.clear();
        _comps.clear();
        comps.clear();
        index[0]=1;
        _comps.push_back("O(1)");
        comps.push_back(_comps);
        while(L--){
            char c;
            cin>>c;
            int cannot_enter=0;
            if(c=='F'){
                ++pipei;
                index[pipei]++;
                if(comps.size()==pipei){
                    vector<string> _empty;
                    _empty.push_back("O(1)");
                    comps.push_back(_empty);
                }
                string i,x,y;
                cin>>i>>x>>y;
                if(defd.count(i)){
                    cout<<"ERR"<<endl;
                    break;
                }else{
                    defd.insert(i);
                    localdefd.insert(i);
                }
                if(cannot_enter);
                else if(x=="n"&&y!="n")cannot_enter = pipei;
                else if(x!="n"&&y=="n"){
                    comps[pipei][index[pipei]-1] = comps[pipei-1][index[pipei-1]-1] * "O(n^1)";
                }
            }else if(c=='E'){
                if(cannot_enter == pipei)cannot_enter=0;
                if(--pipei<0){
                    cout<<"ERR"<<endl;
                    break;
                }else{
                    
                }
            }
        }
        if(pipei){
            cout<<"ERR"<<endl;
        }
        string res="O(1)";
        for(vector<string>::iterator it=comps.back().begin();it!=comps.back().end();++it){
            res=max(res,*it);
        }
        if(res==comp_std)cout<<"Yes"<<endl;
        else cout<<"No"<<endl;
    }
    return 0;
}
