#include<iostream>
#include<string>
#include<cstring>
#include<algorithm>
#include<cstdio>
#include<queue>
#include<vector>
using namespace std;

struct edge {
	int form,to,dist;
	edge(int a=0,int b=0,int c=0) : form(a),to(b),dist(c) {}
};

const int maxn=100000+5,INF=1<<30;
vector<edge> edges,edges_;
vector<int> g[maxn],g_[maxn];
int n,m,k,p;

void addedge(int a,int b,int c) {
	g[a].push_back(edges.size());
	edges.push_back(edge(a,b,c));
}

void addedge_(int a,int b,int c) {
	g_[a].push_back(edges_.size());
	edges_.push_back(edge(a,b,c));
}

bool inq[maxn]={0};
int d[maxn]={0};


void spfa() {
	for (int i=0;i<=n;++i) d[i]=INF;
	d[1]=0;
	queue<int> q;
	q.push(1);
	while (!q.empty()) {
		int u=q.front(); q.pop();
		inq[u]=0;
		for (int i=0;i<g[u].size();++i) {
			edge e=edges[g[u][i]];
			int v=e.to;
			if (d[v]>d[u]+e.dist) {
				d[v]=d[u]+e.dist;
				if (!inq[v]) {
					inq[v]=1;
					q.push(v);
				}
			}
		}
	}
}


int f[maxn];


int dp(int u) {
	int &ans=f[u];
	if (ans) return ans;
	if (u==1) return ans=1;
	for (int i=0;i<g_[u].size();++i) {
		edge e=edges_[g_[u][i]];
		int v=e.to;
		if (d[u]==d[v]+e.dist) {
			ans=(ans+dp(v))%p;
		}
	}
	return ans;
}

int main() {
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	int t;	scanf("%d",&t);
	while (t--) {
		scanf("%d%d%d%d",&n,&m,&k,&p);
		for (int i=0;i<m;++i) {
			int a,b,c;	scanf("%d%d%d",&a,&b,&c);
			addedge(a,b,c);
			addedge_(b,a,c);
		}
		spfa();
		memset(f,0,sizeof(f));
		cout<<dp(n)<<endl;
	}
	return  0;
}
// this problem is written by gzzx wzt
// in fact I am not sure weather it will ac
// god bless me !