#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#define ri register int
using namespace std;
inline int read(){
	int x = 0,f = 1;
	char c = getchar();
	while(c<'0' || c>'9'){
		if(c == '-')
			f = -1;
		c = getchar();
	}
	while(c>='0' && c<='9'){
		x = x*10+c-'0';
		c = getchar();
	}
	return x*f;
}
const int N = 200001;
struct note{
	int to,nxt,w;
}G[N];
int topt = 0,t,k,n,m,p,h[N],d;	
int ans = 0,tot = 0;
void addedge(int x,int y,int z){
	++topt;
	G[topt].nxt = h[x];
	h[x] = topt;
	G[topt].to = y;
	G[topt].w = z;
}
int dis[N],q[N],head = 0,tail = 0,cnt[N];
bool vis[N];
int spfa(){
	head = 0,tail = 0;
	memset(vis,0,sizeof(vis));
	memset(dis,0,sizeof(dis));
	memset(q,0,sizeof(q));
	memset(cnt,0,sizeof(cnt));
	for(ri i = 1;i <= n; ++i)
		dis[i] = 1000;
	dis[1] = 0;
	q[++tail] = 1;
	while(head<=tail){
		head++;
		int u = q[head];
		for(ri i = h[u];i;i =G[i].nxt)
			if(dis[G[i].to] >= dis[u] + G[i].w){
				dis[G[i].to] = dis[u] + G[i].w;
				q[++tail] = G[i].to;
				cnt[G[i].to] ++;
				if(cnt[G[i].to] >= n)
					return -1;
			}
	}
	return dis[n];
}
void dfs(int u){
	if(u == n && tot <= d+k){
		ans++;
		ans%=p;
		return ;
	}
	for(ri i = h[u];i;i=G[i].nxt)
		if(tot + G[i].w <= d+k){
			tot += G[i].w;
			dfs(G[i].to);
			tot -= G[i].w;
		}			
	return ;
}
int main(){
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	t = read();
	while(t--){
		memset(G,0,sizeof(G));
		memset(h,0,sizeof(h));
		n = read(),m = read(),k = read(),p = read();
		for(ri i = 1;i <= m; ++i){
			ri x,y,z;
			x = read(),y = read(),z = read();
			addedge(x,y,z);
		}
		d = spfa();
		ans = 0,tot =0;
		if(d == -1){
			printf("-1\n");
			continue;
		}
		dfs(1);
		printf("%d\n",ans%p);
	}
	return 0;
}
