#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<vector>
using namespace std;

const int N=1010,INF=1<<30;
int n,m,k,p,f,t,l,T,res=0;
int road[N][N],ans[100000],top=0;
int lowcost[N];
bool vis[N];
bool use[N][N];

int FindMin(){
	int one=-1,mmin=INF;
	for(int i=1;i<=n;i++){
		if(vis[i]) continue;
		if(lowcost[i]<mmin){
			mmin=lowcost[i];
			one=i;
		}
	}
	return one;
}

void Dijkstra(int start){
	for(int i=1;i<=n;i++) lowcost[i]=road[start][i];

	memset(vis,false,sizeof(vis));
	vis[start]=true;
	
	for(int i=2;i<=n;i++){
		int k=FindMin();
		
		if(k == -1) return;
		vis[k]=true;
		for(int v=1;v<=n;v++){
			lowcost[v]=min(lowcost[v],lowcost[k]+l);
		}
	}
}

void DFS(int x,int dis){
	if(x==n){
		ans[++top]=dis;
	}
	for(int i=1;i<=n;i++){
		if(i == x) continue;
		if(!use[x][i]&&road[x][i]!=INF){
			use[x][i]=true,use[i][x]=true;
			DFS(i,dis+road[x][i]);
			use[x][i]=false,use[i][x]=false;
		}
	}
}

int main(){
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	
	scanf("%d",&T);
	while(T--){
		scanf("%d%d%d%d",&n,&m,&k,&p);
		for(int i=1;i<=n;i++){
			for(int j=1;j<=n;j++){
				road[i][j]=(i==j)?0:INF;
			}
		}
		
		for(int i=1;i<=m;i++){
			scanf("%d%d%d",&f,&t,&l);
			road[f][t]=min(road[f][t],l);
		}
		
		memset(vis,false,sizeof(vis));
		DFS(1,0);
		
		sort(ans+1,ans+1+top);
		for(int i=1;i<=top;i++){
			if(ans[i]<=ans[1]+k){
				res++;
			}else break;
		}
		printf("%d\n",res);
	}
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}

/*
2
5 7 2 10
1 2 1
2 4 0
4 5 2
2 3 2
3 4 1
3 5 2
1 5 3
2 2 0 10
1 2 0
2 1 0
*/



