#include<iostream>
#include<cstdio>
#include<cstring>
#include<queue>
#include<algorithm>
using namespace std;

const int MAXN=200000+100;
const int INF=0x7f7f7f7f;

struct Edge
{
	int to,w,next;
}E[MAXN];
struct Point
{
	int E,x;
};
int node,head[MAXN];
int T,n,m,k,p,d;

void insert(int u,int v,int w)
{
	E[++node]=(Edge){v,w,head[u]};
	head[u]=node;
}

int spfa()
{
	int dist[100100];
	bool vis[100100];
	memset(dist,0x7f,sizeof(dist));
	memset(vis,0,sizeof(vis));
	dist[1]=0;vis[1]=1;
	queue<int> Q;
	Q.push(1);
	while(!Q.empty())
	{
		int q=Q.front();Q.pop();
		for(int i=head[q];i;i=E[i].next)
		{
			if(dist[E[i].to]>dist[q]+E[i].w)
			{
				dist[E[i].to]=dist[q]+E[i].w;
				if(!vis[E[i].to])
				{
					Q.push(E[i].to);
					vis[E[i].to]=1;
				}
			}
		}
		vis[q]=0;
	}
	return dist[n];
}

int bfs()
{
	int ans[MAXN];
	memset(ans,0,sizeof(ans));
	ans[1]=1;
	queue<Point> Q;
	Q.push((Point){1,0});
	while(!Q.empty())
	{
		Point q=Q.front();Q.pop();
		for(int i=head[q.E];i;i=E[i].next)
		{
			if(q.x+E[i].w<d+k)
			{
				ans[E[i].to]=(ans[E[i].to]+ans[q.E])%p;
				Q.push((Point){E[i].to,q.x+E[i].w});
			}
		}
	}
	return ans[n];
}

int main()
{
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	scanf("%d",&T);
	while(T--)
	{
		scanf("%d %d %d %d",&n,&m,&k,&p);
		for(int i=0;i<m;i++)
		{
			int a,b,c;
			scanf("%d %d %d",&a,&b,&c);
			insert(a,b,c);
		}
		d=spfa();
		int ans=bfs();
		if(ans) printf("%d\n",ans);
			else printf("-1\n");
	}
	return 0;
}
