#include<cstdio>
#include<iostream>
#include<cstring>
#include<cmath>
#include<algorithm>
using namespace std;
const int maxn=200000+10;
struct Edge{
	int to,nxt,w;
}e[maxn];
int head[maxn];
int t,cnt=0,ans=-1;
int n,m,k,p;
int dis[maxn<<1];
bool vis[maxn<<1];

void addedge(int u,int v,int w) {
	e[++cnt].to=v;
	e[cnt].w=w;
	e[cnt].nxt=head[u];
	head[u]=cnt;
}

void Dijkstra(int s) {
	memset(dis,0x3f,sizeof(dis));
	memset(vis,0,sizeof(vis));
	dis[s]=0;
	int minx=0x7fffffff;
	for(int i=1;i<=n;++i) {
		for(int j=1;j<=n;++j) {
			if(!vis[j] && dis[j]<minx) {
				minx=dis[j];
				k=j;
			}
			vis[k]=1;
			for(int j=head[k];j;j=e[j].nxt) {
				if(!vis[e[j].to] && dis[j]>dis[e[j].to]+dis[k])
				dis[j]=dis[e[j].to]+dis[k];
			}
		}
	}
	vis[s]=1;
}

int main()
{
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	scanf("%d",&t);
	while(t--) {
		cnt=0;ans=-1;
		memset(e,0,sizeof(e));
		scanf("%d%d%d%d",&n,&m,&k,&p);
		if(k==0) {
			printf("1\n");
			continue;
		}
		int a,b,c;
		for(int i=1;i<=m;++i) {
			scanf("%d%d%d",&a,&b,&c);
			addedge(a,b,c);
		}
		Dijkstra(1);
		printf("%d\n",ans%p);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
