#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cstdio>
#include <queue>
#include <cmath>
using namespace std;
const int maxn=100007;
const int inf=0x7fffffff;
int first[maxn],next[maxn];
int u[maxn],v[maxn],val[maxn],ne;
int d[maxn];
int f[maxn][53];
int vis[maxn];
int n,m,k,mod;
queue<int> q;
void add_edge(int from,int to,int value)
{
	next[++ne]=first[from];
	first[from]=ne;
	u[ne]=from;
	v[ne]=to;
	val[ne]=value;
}
void init()
{
	ne=0;
	for(int i=1;i<=n;i++)
	{
		first[i]=-1;
		d[i]=inf;	
	}
}
int main()
{
	freopen("park.in","r",stdin);
	freopen("park.out","w",stdout);
	int from,to,value;
	int t,ans=0;
	int cur;
	scanf("%d",&t);
	while(t--)
	{
		memset(vis,0,sizeof(vis));
		ans=0;
		scanf("%d %d %d %d",&n,&m,&k,&mod);
		init();
		for(int i=1;i<=m;i++)
		{
			scanf("%d %d %d",&from,&to,&value);
			add_edge(from,to,value);
		}
		q.push(1);
		d[1]=0;
		while(!q.empty())
		{
			cur=q.front();q.pop();
			for(int nod=first[cur];nod!=-1;nod=next[nod])
			{
				if(d[v[nod]] > d[u[nod]]+val[nod])
				{
					d[v[nod]] = d[u[nod]]+val[nod];
					q.push(v[nod]);
				}
			}
		}
		q.push(1);
			f[1][0]=1;
		while(!q.empty())
		{
			cur=q.front();q.pop();
			vis[cur]=1;
			for(int edge=first[cur];edge!=-1;edge=next[edge])
			{
				for(value=0;value<=k;value++)
				{
					if(f[cur][value])
					{
					/*	if(d[v[edge]]-d[cur] <= val[edge])
						{
					*/
							if((val[edge]-(d[v[edge]]-d[cur])) + value <= k)
							{
								f[v[edge]][value+(val[edge]-(d[v[edge]]-d[cur]))]++;
							}
						
					}	
				}
				if(!vis[v[edge]])
					q.push(v[edge]);
			}
		}
		for(int i=0;i<=k;i++)
		{
			ans+=f[n][i];
			ans%=mod;
		}
		printf("%d\n",ans);
	}
	
	return 0;
}
