#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <vector>
#include <map>
using namespace std;
struct Long{
   int t;
   map<int,int> go;
   vector<int> land;     
};

int tall[100001]={0};
Long trees[100001];

int root(int p){
    while(p!=trees[p].t){
        trees[p]=trees[trees[p].t];
        p=trees[p].t;
    }
    return p;
}

void unionTree(int p,int q,int l){
     int pid=root(p);
     int qid=root(q);
     if(tall[pid]>tall[qid]){
         trees[pid]=trees[qid];
         tall[pid]+=tall[qid];
     }else{
         trees[qid]=trees[pid];
         tall[qid]+=tall[pid];
     }
     
     trees[p].go[q]=l;
     trees[p].land.push_back(q);
     trees[q].go[p]=l;
     trees[q].land.push_back(p);
}

bool isConnect(int p,int q){
     return root(p)==root(q);
}

void init(int n){
     for(int i=1;i<=n;i++)
         {tall[i]=1; trees[i].t=i;}
}

int main(){
    FILE *fin,*fout;
    fin=fopen("park.in","r");
    fout=fopen("park.out","w");
    
    fprintf(fout,"-1");
    
    fclose(fin);
    fclose(fout);
    return 0;
}
